function [O,P] = ifda(O, Mflip, obs,acc)
% Information-Form Data Association (IFDA)
% An implementation of the method from
% [*] Schumitsch,  B., Thrun, S.,  Bradski, G., and Olukotun,  K.: The
%     Information-Form  Data  Association   Filter  ,  Proceedings  of
%     Conference on Neural  Information Processing Systems (NIPS), MIT
%     Press, 2005
% last edited: <2010-10-24 21:52:04 pliz>

O = transitOmega(O,Mflip);  % propagate Omega to the next step
O = updateOmega(O,obs,acc); % update Omega based on an incoming observation
[E,P] = predictErr(O,tru);      % predict next permutation and get the
                            % error

% Copyright (C) 2010, Sergey Plis  [s.m.plis@gmail.com]
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free  Software Foundation; either  version 2 of the  License, or
% (at your option) any later version.
%
% This program is distributed in the  hope that it will be useful, but
% WITHOUT  ANY   WARRANTY;  without  even  the   implied  warranty  of
% MERCHANTABILITY or  FITNESS FOR A  PARTICULAR PURPOSE.  See  the GNU
% General Public License for more details.
% Local Variables:
% mode: MATLAB
% write-file-hooks:   (time-stamp)
% time-stamp-active:  t
% time-stamp-start:   "last edited: <"
% time-stamp-end:     ">"
% time-stamp-line-limit: 20
% End:
